package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type ListSecurityGroupRulesLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewListSecurityGroupRulesLogic(ctx context.Context, svcCtx *svc.ServiceContext) *ListSecurityGroupRulesLogic {
	return &ListSecurityGroupRulesLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *ListSecurityGroupRulesLogic) ListSecurityGroupRules(req *types.ListSecurityGroupRulesReq) (resp *types.ListSecurityGroupRulesResp, err error) {
	// todo: add your logic here and delete this line
	ListSecurityGroupRulesReq := &openstack.ListSecurityGroupRulesReq{}
	err = copier.CopyWithOption(ListSecurityGroupRulesReq, req, copier.Option{Converters: utils.Converters})
	ListSecurityGroupRulesResp, err := l.svcCtx.OpenstackRpc.ListSecurityGroupRules(l.ctx, ListSecurityGroupRulesReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&ListSecurityGroupRulesResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &ListSecurityGroupRulesResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
